#!/usr/bin/env python
########### Author: Mungkie
########### Copyright: Mungkie 2010
########### Creation Date: July 22nd 2010
########### Last update Date: August 31 2010
##########################################################################################

from Tkinter import *
import sys
import EmcGuiProcs
import os

import paramentry

stepnames = ["type 0:step/dir","type 1: up/down","type 2: quadrature","type 3: three phase, full step","type 4: three phase, half step","type5: 4 phase unipolar","type6: 4 phase unipolar","type7:4 phase bipolar","type8:4 phase bipolar","type9:four phase, half step unipolar","type10:four phase, half step bipolar","type11:type 11: five phase, full step","type12:types 12: five phase, full step","type 13: five phase, half step","type 14: five phase, half step"]

step_help = ["#Two pins, one for step and one for direction. make-pulses must run at least twice for each step (once to set the step pin true, once to clear it). This limits the maximum step rate to half (or less) of the rate that can be reached by types 2-14. The parameters steplen and stepspace can further lower the maximum step rate. Parameters dirsetup and dirhold also apply to this step type.",
"#Two pins, one for 'step up' and one for 'step down'. Like type 0, make-pulses must run twice per step, which limits the maximum speed.",
"#Two pins, phase-A and phase-B. For forward motion, A leads B. Can advance by one step every time make-pulses runs.",
"#Three pins, phase-A, phase-B, and phase-C. Three steps per full cycle, then repeats. Only one phase is high at a time - for forward motion the pattern is A, then B, then C, then A again.",
"#Three pins, phases A through C. Six steps per full cycle. First A is high alone, then A and B together, then B alone, then B and C together, etc.",
"#Four pins, phases A through D. Four steps per full cycle. Types 5 and 6 are suitable for use with unipolar steppers, where power is applied to the center #tap of each winding, and four open-collector transistors drive the ends.", 
"#Four pins, phases A through D. Four steps per full cycle. Types 5 and 6 are suitable for use with unipolar steppers, where power is applied to the center #tap of each winding, and four open-collector transistors drive the ends.", 
"#Four pins, phases A through D. Four steps per full cycle. Types 7 and 8 are suitable for bipolar steppers, driven by two H-bridges.",
"#Four pins, phases A through D. Four steps per full cycle. Types 7 and 8 are suitable for bipolar steppers, driven by two H-bridges.",
"#Four pins, phases A through D. Eight steps per full cycle. Type 9 is suitable for unipolar drive,",
"#Four pins, phases A through D. Eight steps per full cycle. Type 10 is suitable for bipolar drive",
"#**types 11 : five phase, full step Five pins, phases A through E. Five steps per full cycle. See HAL reference manual for the patterns.",
"#**type 12: five phase, full step #Five pins, phases A through E. Five steps per full cycle. See HAL reference manual for the patterns.",
"#**type 13: five phase, half step Five pins, phases A through E. Ten steps per full cycle. See HAL reference manual for the patterns.",
"#**type 14: five phase, half step Five pins, phases A through E. Ten steps per full cycle. See HAL reference manual for the patterns." ]

##### data structures for the stepgen steptypes
type0 = [ "step", "dir"]
type1 = [ "up", "down"]
type2 = [ "phase-A", "phase-B"]
type3 = [ "phase-A", "phase-B", "phase-C" ]
type5 = [ "phase-A", "phase-B", "phase-C", "phase-D" ]
type11= [ "phase-A", "phase-B", "phase-C", "phase-D", "phase-E" ]
steptypes = [ type0, type1, type2, type3, type3, type5, type5 ,type5 ,type5 ,type5 ,type5, type11, type11, type11, type11]


stepgen_pins_in = [ "position-cmd", "velocity-cmd", "enable" ]
stepgen_pins_in_type = [ "float", "float", "bit" ]
stepgen_pins_in_help = [ "#Commanded position, in length units (see parameter position-scale).", "#Commanded velocity, in length units per second (see parameter position-scale).", "#Enables output steps - when false, no steps are generated." ]

#**stepgen.N.position-cmd float in (position mode only)
#**stepgen.N.velocity-cmd float in (velocity mode only)	
#**stepgen.N.enable bit in

stepgen_pins_out = [  "counts","position-fb", "step", "dir", "up", "down"]
stepgen_pins_out_type = [  "s32", "float", "bit", "bit", "bit", "bit" ]
stepgen_pins_out_help = [  "#The current position, in counts, for channel N. Updated by capture-position.", "#The current position, in length units (see parameter position-scale). Updated by capture-position. The resolution of position-fb is much finer than a single step. If you need to see individual steps, use counts.", "(step type 0 only) #Step pulse output.", "(step type 0 only) #Direction output: low for forward, high for reverse.", "(step type 1 only) #Count up output, pulses for forward steps.", "(step type 1 only) #Count down output, pulses for reverse steps." ]

#**stepgen.N.counts s32 out
#**stepgen.N.position-fb float out
#**stepgen.N.step bit out (step type 0 only)
#**stepgen.N.dir bit out (step type 0 only)
#**stepgen.N.up bit out (step type 1 only)
#**stepgen.N.down bit out (step type 1 only)


stepper_ini_paramnames = ["AXIS_", "DRIVE", "TYPE", "HOME", "MAX_VELOCITY", "MAX_ACCELERATION", "STEPGEN_MAXACCEL","SCALE", "FERROR", "MIN_FERROR ", "MIN_LIMIT", "MAX_LIMIT","HOME_OFFSET","BACKLASH","INPUT_SCALE","OUTPUT_SCALE","HOME_SEARCH_VEL","HOME_LATCH_VEL",
"HOME_USE_INDEX","HOME_IGNORE_LIMITS","HOME_SEQUENCE"]

stepper_ini_params = [0,0,"ANGULAR:LINEAR","0.0","40.0","40.0","40.5",".1","1",".25","-720","720","0.0","0.000",
"4000","1.0","0.0","0.0","NO","NO","0"]

stepper_ini_help = ["AXIS_", "DRIVE", "TYPE", "HOME", "MAX_VELOCITY", "MAX_ACCELERATION", "STEPGEN_MAXACCEL","SCALE", "FERROR", "MIN_FERROR ", "MIN_LIMIT", "MAX_LIMIT","HOME_OFFSET","","","","","","","",""]


stepper_hal_paramnames = [ "A encoder", "B encoder", "Dir up", "Dir Down"]
stepper_hal_paramvalues = ["","","",""]
stepper_hal_help = ["","","",""]

stepper_IOpins_in = list(paramentry.IOpins_in)

stepper_IOpins_out = list(paramentry.IOpins_out)


stepper_IO = [ ["A encoder", "B encoder"], ["Dir up", "Dir Down"] ] 

class stepper(paramentry.paramentry):
	global stepper_ini_paramnames, stepper_ini_paramvalues, stepper_ini_help
	ini_paramvalues = list(stepper_ini_params)
	ini_paramnames = list(stepper_ini_paramnames)
	ini_params = [ list(ini_paramnames), list(ini_paramvalues), list(stepper_ini_help) ]
	IOpins_out = list(stepper_IOpins_out)
	IOpins_in = list(stepper_IOpins_in)
	current_help = step_help[0]
	IO=list(["",steptypes[0]]) #stepper_IO)
	#hal_params = [stepper_hal_paramnames, stepper_hal_paramvalues, stepper_hal_help]
	DRIVE_TYPES= list(stepnames)
	DRIVE_IO = list(steptypes)
	
	def postinit(self) :
		"exec after init"
		#print "postinitntin "

	def get_drive(self,a):
		
		i=0
		for n in self.DRIVE_TYPES :
			if (a == n ) :
				print "founf"  + str(a)
				#qop['menu'].insert('end', 'command', label='foo', command=lambda : self.get_drive('foo'))
				self.IO[1]=steptypes[i]
				self.current_values[3][1]=["","","","","","",""]
				self.get_optsf("out")
				print "getdrive"  + str(a)
				print str(self.current_values)
				self.current_values[2][1]=str(i)
				self.params_entry.set_params( [], self.current_values[2])
				self.current_help = step_help[i]
				#self.lb_cb(["out"])
			i=i+1

	###################################################################
	def print_hal(self,num, a):
		id = "j" + str(a[0])  + "-"
		j = str(a[0])
		jnum=int(a[0])
		stp_type=int(a[2][1])
		inp = a[3][0]
		outp = a[3][1]
		#print "outpppppppp---" + str(outp) + "\n\n" + str(a) + "\n\n" + str(a[3][1])+ "\n\n" + str(a[2])
		if(a[1]==0):










			print "\n\n\n# stepper for joint " + id +  "##\n"

			"""
newsig J0pos float
linksp J0pos <= axis.0.motor-pos-cmd
linksp J0pos => axis.0.motor-pos-fb
linksp J0pos => ddt.0.in
linksp J0pos scale.0.in
setp scale.0.gain 1
net J0scaled scale.0.out pumagui.joint1
"""
			#print "addf ddt." + str(int(j)*2)  + " servo-thread"
			#print "addf ddt.1 servo-thread"






			print "addf ddt." + str(int(j)*2)  + " servo-thread"
			print "addf ddt." + str(1+(int(j)*2) ) + " servo-thread"


			print "net " + id + "pos  axis." + j + ".motor-pos-cmd => axis." + j + ".motor-pos-fb test.joint" + j 
#			print "newsig " + id + "pos float"




#			print "linksp " + id + "pos <= axis." + j + ".motor-pos-cmd"
#			print "linksp " + id + "pos => axis." + j + ".motor-pos-fb"
			#print "newsig " + id + "motor-fb float"

			#print "linksp " + id + "pos => stepgen." + j + ".position-cmd"
			#print "linksp " + id + "motor-fb <= stepgen." + j + ".position-fb"


			#print "linksp " + id + "motor-fb => axis." + j + ".motor-pos-fb"

			print "newsig " + id + "vel float"
			print "newsig " + id + "acc float"
			print "linksp " + id + "pos => ddt." + str(int(j)*2 ) + ".in"
			print "linkps ddt." + str(int(j)*2 ) + ".out => " + id + "vel"
			print "linksp " + id + "vel => ddt." + str(1+(int(j)*2) ) + ".in"
			print "linkps ddt." + str(1+(int(j)*2) ) + ".out => " + id + "acc"
			#print "linksp " + id + "pos => ddt." + j + ".in"
			print "linksp " + id + "pos => stepgen." + j + ".position-cmd"
			#print "linksp " + id + "pos <= stepgen." + j + ".position-fb"

			print "linksp " + id + "pos scale." + j + ".in"
			#print "setp scale.0.gain 1
			


	# connect position commands from motion module to step generator
			#print "net " + id + "pos axis." + j + ".motor-pos-cmd => stepgen." + j + ".position-cmd"
			#print "net " + id + "pos axis." + j + ".motor-pos-cmd => stepgen." + j + ".position-cmd"
	# connect position feedback from step generators
	# to motion module
			#print "net " + id + "pos-fb stepgen." + j + ".position-fb => axis." + j + ".motor-pos-fb"
			#print "
			#print "net " + id + "pos-fb stepgen." + j + ".position-fb => axis." + j + ".motor-pos-fb"
	# connect enable signals for step generators
			print "net " + id + "en axis." + j + ".amp-enable-out => stepgen." + j + ".enable"

	# set stepgen module scaling - get values from ini file
			print "setp stepgen." + j + ".position-scale [AXIS_" + j + "]SCALE"
	# set stepgen module accel limits - get values from ini file
			print "setp stepgen." + j + ".maxaccel [AXIS_" + j + "]STEPGEN_MAXACCEL"
			i=0
			for sttyp in steptypes[stp_type] :
	# connect signals to step pulse generator outputs


				print "net " + id + sttyp +" <= stepgen." + j + "." + sttyp	#step"
				#print "net " + id + "dir  <= stepgen." + j + "." + dir"

				if(outp[i]!="") :
					print "net " + id + sttyp + " => " + outp[i]

			#parport.1.pin-" + str( (int(a[0])*2) +1).zfill(2) + "-out"
					#print "net " + id + "dir  => " + outp[1]
			#parport.1.pin-" + str((int(a[0])*2)+2).zfill(2) + "-out"
				i=i+1
			print "newsig " + id + "flt bit"
			print "linksp " + id + "flt axis." + str(a[0]) +  ".amp-fault-in"
			if( stp_type == 0 ) :
				print "setp stepgen." + str(a[0]) +  ".dirhold 35000"
				print "setp stepgen." + str(a[0]) +  ".dirsetup 35000"
			print "setp stepgen." + str(a[0]) +  ".steplen 1"
			if( stp_type == 1 or stp_type == 0 ) :
				print "setp stepgen." + str(a[0]) +  ".stepspace 0"

	###################################################################
	def print_postgui_hal(self,num, a):
		print "net J0scaled pyvcp.joint0"

	###################################################################
	def print_ini(self,num, aa):
		#print "#stepper ini print" + str(aa)
		if(aa[1]==0):
			a=aa[2]
			i = 0
			for val in self.ini_paramnames :
				if ( i == 0 ):
					print "[" + str(val ) + str(num) + "]"
				else:
					print str(val ) + " = " + str(a[i])
				i=i+1
			print "# please be aware stepper config not yet complete" + str(a[1]) + "\n"



